#define MAXSEG 20
#define MAXRNUM 1.0e5
#define MINRNUM 1.0e-3

extern int me, me_proc, host;  /* processor id information */

extern int ndims_cube;         /* dimension of allocated cube */
extern int ndims_row;          /* dim of subcube to which a row is assigned */
extern int ndims_col;          /* dim of subcube to which a col is assigned */

extern int nprocs_cube;        /* num of procs in the allocated cube */
extern int nprocs_row;         /* num of procs to which a row is assigned */
extern int nprocs_col;         /* num of procs to which a col is assigned */
extern int max_procs;          /* max num of procs in any dimension */

extern int mask_cube;          /* bcast mask for the allocated subcube */
extern int mask_row;           /* mask to bcast along a row */
extern int mask_col;           /* mask to bcast along a col */

extern int nrows_matrix;       /* number of rows in the matrix */
extern int ncols_matrix;       /* number of cols in the matrix */
extern int matrix_size;        /* order of matrix=nrows_matrix=ncols_matrix */

extern int my_first_row;       /* proc position in a row */
extern int my_first_col;       /* proc position in a col */

extern int my_rows;            /* num of rows I own */
extern int my_cols;            /* num of cols I own */

extern int nsegs_row;          /* num of segs to which each row is assigned */
extern int ncols_seg;          /* num of cols in each segment */
extern int ncols_last;         /* num of cols in the rightmost segment */

extern int my_cols_seg;        /* num of cols I own in a seg */
extern int my_cols_last;       /* num of cols I own in the rightmost seg */

extern int bytes_per_seg;      /* number of bytes in a segment */

extern double **mat;           /* incore storage for col being factored */

extern double *col1;           /* ptrs to col used for updating a col */
extern double *col2;           /* ptr to col received in message buf */
extern double *row1;           /* ptr to diagonal row */
extern double *row2;           /* ptr to pivot row */
